package events;

import fr.cnes.genius.exception.GException;
import fr.cnes.genius.lowLevel.GFrame;
import fr.cnes.genius.lowLevel.GPanel;
import fr.cnes.genius.main.GReadWrite;
import fr.cnes.genopus.events.GPEventSelector;
import fr.cnes.genopus.events.GPEventSelector.GPEventsEnum;
import fr.cnes.sirius.addons.patriusdataset.PatriusDataset;
import fr.cnes.sirius.patrius.propagation.events.EventDetector.Action;
import fr.cnes.sirius.patrius.utils.exception.PatriusException;

/**
 * Testing GPEventSelector.
 * @author goesterjf
 *
 */
public class TestGPEvent extends GPanel implements GReadWrite {

    private GPEventSelector eventSelector;
    
    public TestGPEvent() {
        
        final Action[] actionsToShow = { Action.RESET_STATE, Action.STOP};
        eventSelector = new GPEventSelector("Events:", actionsToShow, GPEventsEnum.APSIDE, GPEventsEnum.NODE);
        
    }

    public void generic() throws GException {
        put(eventSelector);
    }

    public void display() throws GException {
        generic();
    }

    public void read() throws GException {
        generic();
    }

    public void write() throws GException {
        generic();
    }

    /**
     * @param args
     * @throws OrekitException 
     */
    public static void main(String[] args) throws PatriusException {

        PatriusDataset.addResourcesFromPatriusDataset();
        
        //GPanTest panTest = new GPanTest("Events", new TestGPEvent(), "events.xml");
        GFrame panTest = new GFrame("Events", new TestGPEvent());
        panTest.display();

    }

}
