package misc;

import fr.cnes.genius.exception.GException;
import fr.cnes.genius.lowLevel.GPanel;
import fr.cnes.genius.main.GReadWrite;
import fr.cnes.genius.utils.GPanTest;
import fr.cnes.genopus.exception.GPOrbitException;
import fr.cnes.genopus.orbits.GPOrbit;
import fr.cnes.sirius.addons.patriusdataset.PatriusDataset;
import fr.cnes.sirius.patrius.frames.Frame;
import fr.cnes.sirius.patrius.frames.FramesFactory;
import fr.cnes.sirius.patrius.frames.configuration.FramesConfiguration;
import fr.cnes.sirius.patrius.frames.configuration.FramesConfigurationFactory;
import fr.cnes.sirius.patrius.math.util.FastMath;
import fr.cnes.sirius.patrius.orbits.CartesianOrbit;
import fr.cnes.sirius.patrius.orbits.PositionAngle;
import fr.cnes.sirius.patrius.orbits.orbitalparameters.CartesianParameters;
import fr.cnes.sirius.patrius.orbits.orbitalparameters.KeplerianParameters;
import fr.cnes.sirius.patrius.time.AbsoluteDate;
import fr.cnes.sirius.patrius.time.TimeScalesFactory;
import fr.cnes.sirius.patrius.utils.Constants;
import fr.cnes.sirius.patrius.utils.exception.PatriusException;

/**
 * Tutorial for using GPOrbit.
 * @author goesterjf
 *
 */
public class TestGPOrbit extends GPanel implements GReadWrite {

    private GPOrbit gpOrbit;
    
    public TestGPOrbit() throws PatriusException, GPOrbitException {
        
        gpOrbit = new GPOrbit();
        
//        final Frame CIRF = FramesFactory.getCIRF();
//        final TimeScale TUC = TimeScalesFactory.getUTC();
//        final AbsoluteDate date0 = new AbsoluteDate(2010, 1, 1, 12, 0, 0., TUC);
//        final double ae = Constants.WGS84_EARTH_EQUATORIAL_RADIUS;
//        final double mu = Constants.WGS84_EARTH_MU;
//        ApsisOrbit orbit = new ApsisOrbit(ae+200.e+3, ae+300.e+3, FastMath.toRadians(51.6), 0., 0., 0., PositionAngle.MEAN, CIRF, date0, mu);
//        gpOrbit = new GPOrbit("Orbit", orbit);
//        
//        GPRefFrame[] tabFrames = gpOrbit.getAvailableFrames();
//        GPRefFrame[] tabFramesSimplified = new GPRefFrame[3];
//        tabFramesSimplified[0] = tabFrames[0];
//        tabFramesSimplified[1] = tabFrames[1];
//        tabFramesSimplified[2] = tabFrames[6];
//        gpOrbit.setAvailableFrames(tabFramesSimplified);
//                
//        GPParamsType[] tabParams = gpOrbit.getAvailableParamsTypes();
//        GPParamsType[] tabParamsSimplified = new GPParamsType[4];
//        tabParamsSimplified[0] = tabParams[0];
//        tabParamsSimplified[1] = tabParams[1];
//        tabParamsSimplified[2] = tabParams[5];
//        tabParamsSimplified[3] = tabParams[7];
//        gpOrbit.setAvailableParamsTypes(tabParamsSimplified);
        
    }

    public void display() throws GException {
        generic();
    }

    @Override
    public void generic() throws GException {
        put(gpOrbit);
    }

    public void read() throws GException {
        generic();
    }

    public void write() throws GException {
        generic();
    }

    /**
     * @param args
     * @throws OrekitException 
     * @throws GPOrbitException 
     */
    public static void main(String[] args) throws PatriusException, GPOrbitException {

        PatriusDataset.addResourcesFromPatriusDataset() ;

        // Simple configuration
        FramesConfiguration configSimple = FramesConfigurationFactory.getSimpleConfiguration(true);
        FramesFactory.setConfiguration(configSimple);

        GPanTest frame = new GPanTest("Orbit", new TestGPOrbit(), "GPOrbit.xml");
        //GFrame frame = new GFrame("Orbit", new TestGPOrbit());
        frame.display();

    }

}
