package observer;
import fr.cnes.genius.constraints.GConstraint;
import fr.cnes.genius.exception.GException;
import fr.cnes.genius.lowLevel.GPanel;
import fr.cnes.genius.lowLevel.GTabbedPane;
import fr.cnes.genius.main.GReadWrite;
import fr.cnes.genius.utils.GPanTest;
import fr.cnes.genopus.forces.GPEarthPotentialForceModel.AttractionModelsEnum;
import fr.cnes.genopus.forces.GPForceModels;
import fr.cnes.genopus.vehicle.GPVehicle;
import fr.cnes.sirius.addons.patriusdataset.PatriusDataset;
import fr.cnes.sirius.patrius.utils.exception.PatriusException;

/**
 * Testing Observer/Observable functionality.
 * @author goesterjf
 *
 */
public class TestForObserver extends GPanel implements GReadWrite {
	
	/** Tabbedpane */
	private GTabbedPane tabs;
	
	/**
	 * Constructor.
	 * @throws GException
	 */
	public TestForObserver () throws GException {
		
		tabs = new GTabbedPane("data");  		
		tabs.setConstraint(new GConstraint(GConstraint.grow(), GConstraint.push()));
		
		GPVehicle veh = new GPVehicle();
		tabs.addTab("Vehicle", veh);
        AttractionModelsEnum[] attractionModelsAvailable = { AttractionModelsEnum.BALMINO };
		GPForceModels forces = new GPForceModels("MyModels", AttractionModelsEnum.BALMINO, attractionModelsAvailable , true, true, true, true, true, true);
		tabs.addTab("Forces", forces);
		
		forces.registerObserver(veh);

	}

	public void display() throws GException {
		generic();
		}

	@Override
	public void generic() throws GException {
		put(tabs);
	}
	
	public void read() throws GException {
		generic();
		}

	public void write() throws GException {
		generic();
		}

	public static void main(String[] args) throws GException, PatriusException {
		
        PatriusDataset.addResourcesFromPatriusDataset();

		TestForObserver test = new TestForObserver();
		GPanTest panTest = new GPanTest("TestForObserver", test, "TestForObserver.xml");
		panTest.display();

	}

}
